import { __decorate, __metadata, __param } from "tslib";
import { inject, service } from '@loopback/core';
import { RedisPublisherClientService } from 'loopback4-redis-pubsub';
import { RedisClient } from 'redis';
import { REDIS_PUBSUB_DATA_HANDLER, RedisPubSubDataHandlerProvider } from '../services';
let RedisPubSubLifecycleObserver = class RedisPubSubLifecycleObserver {
    constructor(redisPublisherClient, redisPubSubDataHandler) {
        this.redisPublisherClient = redisPublisherClient;
        this.redisPubSubDataHandler = redisPubSubDataHandler;
        this.status = 'not-initialized';
        console.log(this + ':created');
    }
    init() {
        this.status = `initialized`;
        console.log(this + ':' + this.status);
    }
    start() {
        this.status = `started`;
        console.log(this + ':' + this.status);
        const messageStr = JSON.stringify({ source: 'redis-pubsub', status: this.status });
        this.redisPublisherClient.publish('app', messageStr);
    }
    stop() {
        this.status = `stopped`;
        console.log(this + ':' + this.status);
    }
    toString() {
        return RedisPubSubLifecycleObserver.name;
    }
};
RedisPubSubLifecycleObserver = __decorate([
    __param(0, service(RedisPublisherClientService)),
    __param(1, inject(REDIS_PUBSUB_DATA_HANDLER)),
    __metadata("design:paramtypes", [RedisClient,
        RedisPubSubDataHandlerProvider])
], RedisPubSubLifecycleObserver);
export { RedisPubSubLifecycleObserver };
//# sourceMappingURL=redis-pubsub.observer.js.map