import { __decorate, __metadata, __param } from "tslib";
import { BindingKey, inject } from '@loopback/core';
import { SocketIoBindings, SocketIoServer } from '@loopback/socketio';
import { IdentifierSeperator } from '@xtnd-dynamics/xd-data';
export const REDIS_PUBSUB_DATA_HANDLER = BindingKey.create('redis.pubsub.dataHandler');
let RedisPubSubDataHandlerProvider = class RedisPubSubDataHandlerProvider {
    constructor(socketServer) {
        this.socketServer = socketServer;
        console.log(this + ':created');
    }
    value() {
        return this.action.bind(this);
    }
    async action(event) {
        console.log(this + ':action');
        const message = event.message;
        const eventName = [
            message.event,
            message.model,
            message.id,
        ].join(IdentifierSeperator);
        // @ts-ignore
        this.socketServer.io.sockets.emit(eventName, message);
    }
    toString() {
        return RedisPubSubDataHandlerProvider.name;
    }
};
RedisPubSubDataHandlerProvider = __decorate([
    __param(0, inject(SocketIoBindings.SERVER.key)),
    __metadata("design:paramtypes", [SocketIoServer])
], RedisPubSubDataHandlerProvider);
export { RedisPubSubDataHandlerProvider };
//# sourceMappingURL=redis-pubsub-data.service.js.map